﻿using System;
using System.Collections.ObjectModel;

namespace SilverlightApplication1
{
    public class MyDataObject
    {
        public int Int { get; set; }
        public string StringValue { get; set; }
        public double DoubleValue { get; set; }
        public DateTime DateTimeValue { get; set; }

        public ObservableCollection<MyDataObject> HierarchicalData { get; set; }
    }

    public class MyData : ObservableCollection<MyDataObject>
    {
        private int _generatedItemsCount = 0;

        private void FillDataCollection(ObservableCollection<MyDataObject> collection, int rowCount)
        {
            for (int i = 0; i < rowCount; i++)
            {
                this._generatedItemsCount++;
                collection.Add(new MyDataObject()
                {
                    Int = this._generatedItemsCount,
                    StringValue = "Item " + this._generatedItemsCount.ToString(),
                    DoubleValue = Math.IEEERemainder(this._generatedItemsCount,2),
                    DateTimeValue = DateTime.Now
                });
            }
        }

        public MyData()
        {
            FillDataCollection(this, 50);

            foreach (MyDataObject dataObject in this)
            {
                dataObject.HierarchicalData = new ObservableCollection<MyDataObject>();
                FillDataCollection(dataObject.HierarchicalData,2);
            }
        }
    }
}
